#include <windows.h>
#include <bwcc.h>
#include <alloc.h>
#include <string.h>
#include <stdlib.h>
#include "CTL3D.H"          // 3-D control Header


HINSTANCE MainInstance = NULL;
char *KEYS[4] = {"HKEY_CLASS_ROOT", "HKEY_CURRENT_USER",
                 "HKEY_LOCAL_MACHINE", "HKEY_USERS"};

BOOL   _3D = FALSE;
LPSTR  Value = NULL;
int    Mask = 0;
BOOL   Stopped = FALSE;
HKEY   TheKey = 0;
HWND   Dialog = 0;
BOOL   WholeWord = FALSE;
BOOL   CaseSensitive = FALSE;
BOOL   ClickClick = FALSE;
LPTSTR valueStr = new char far[MAX_PATH];
LPBYTE data = new unsigned char far[MAX_PATH];
char*  SubKeyName = new char far[MAX_PATH];
char*  value = new char far[MAX_PATH];
char   KEYname[MAX_PATH];
char*  szWinName = "Registry Tree ";
char*  ThePath = NULL;

char*  AboutText = {" REG_FIND v1.00r0\nBy E. Thioux (c) 1994."};


#define IDSTOP  100
#define IDABOUT 108

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK SeekDialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
HKEY SearchKey(HKEY KeyName, char* Name);

#pragma option -w-aus
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPSTR lpszCmdLine,
						  int /*nCmdShow*/ )
{
 char* p;

 p = strtok(lpszCmdLine, "/");
 if (p)
  if (strcmp(strupr(p), "3D") == 0)
     {
      _3D = TRUE;
      Ctl3dRegister(MainInstance);        // setup for 3-d controls (CTL3D.DLL)
      Ctl3dAutoSubclass(MainInstance);    // auto subclassing for all controls
     }

 MainInstance = hInstance;

 DialogBox(hInstance, MAKEINTRESOURCE(102), GetActiveWindow(), (DLGPROC) DialogProc);

 delete valueStr;
 delete data;
 delete SubKeyName;
 delete value;
 if (_3D)
    Ctl3dUnregister(MainInstance);        // unregister the 3D controls
 return 0;
}

void Go()
{
  Dialog = CreateDialog(MainInstance, MAKEINTRESOURCE(103), GetActiveWindow(), (DLGPROC) SeekDialogProc);

  if (Dialog)
     {
      if ((Mask & 1) == 1)
        {
         RegOpenKeyEx(HKEY_CLASSES_ROOT, NULL, 0, KEY_ALL_ACCESS, &TheKey);
         SearchKey(TheKey, KEYS[0]);
         Stopped = FALSE;
         RegCloseKey(TheKey);
        }
      if ((Mask & 2) == 2)
        {
         RegOpenKeyEx(HKEY_CURRENT_USER, NULL, 0, KEY_ALL_ACCESS, &TheKey);
         SearchKey(TheKey, KEYS[1]);
         Stopped = FALSE;
         RegCloseKey(TheKey);
        }
      if ((Mask & 4) == 4)
        {
         RegOpenKeyEx(HKEY_LOCAL_MACHINE, NULL, 0, KEY_ALL_ACCESS, &TheKey);
         SearchKey(TheKey, KEYS[2]);
         Stopped = FALSE;
         RegCloseKey(TheKey);
        }
      if ((Mask & 8) == 8)
        {
         RegOpenKeyEx(HKEY_USERS, NULL, 0, KEY_ALL_ACCESS, &TheKey);
         SearchKey(TheKey, KEYS[3]);
         Stopped = FALSE;
         RegCloseKey(TheKey);
        }
     }

  EndDialog(Dialog, 0);
}

// ----------------------------------------------------------------------------------------



BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM /*lParam*/)
{
 static PAINTSTRUCT PS;
 static RECT Rect;
 static HBITMAP BitBrush;
 static HBRUSH  Brush = 0;


 switch (msg)
   {
    case WM_COMMAND:
      switch (LOWORD(wParam))
        {
         case IDOK:
            SendDlgItemMessage(hwndDlg, 101, WM_GETTEXT, 255, (LPARAM) Value);
            Mask  = SendDlgItemMessage(hwndDlg, 102, BM_GETCHECK, 0, 0);
            Mask += SendDlgItemMessage(hwndDlg, 103, BM_GETCHECK, 0, 0) << 1;
            Mask += SendDlgItemMessage(hwndDlg, 104, BM_GETCHECK, 0, 0) << 2;
            Mask += SendDlgItemMessage(hwndDlg, 105, BM_GETCHECK, 0, 0) << 3;
            WholeWord = SendDlgItemMessage(hwndDlg, 106, BM_GETCHECK, 0, 0);
            CaseSensitive = SendDlgItemMessage(hwndDlg, 107, BM_GETCHECK, 0, 0);
            Go();
            break;
         case IDCANCEL:
            EndDialog(hwndDlg, wParam);
            return TRUE;
         case IDABOUT:
            MessageBox(hwndDlg, AboutText, "About...", MB_OK);
            break;
        }; break;

    case WM_PAINT:
      if (!_3D)
         {
          BeginPaint(hwndDlg, &PS);
          SelectObject(PS.hdc, Brush);
          GetClientRect(hwndDlg, &Rect);
          Rectangle(PS.hdc, 0, 0, Rect.right, Rect.bottom);
          EndPaint(hwndDlg, &PS);
         }
      break;

     case WM_CTLCOLORSTATIC:
     case WM_CTLCOLORBTN:
     case WM_CTLCOLORLISTBOX:
      if (!_3D)
         {
          SetTextColor((HDC) wParam, RGB(0, 0, 0));
          SetBkColor((HDC) wParam, RGB(192, 192, 192));
          return (LRESULT) GetStockObject(LTGRAY_BRUSH);
         }
      else
         break;

     case WM_DESTROY:
      if (!_3D)
         DeleteObject(BitBrush);
      break;
     case WM_INITDIALOG:
      Value = new char far[256];
      if (!_3D)
         {
          BitBrush = LoadBitmap(MainInstance, MAKEINTRESOURCE(100));
          Brush = CreatePatternBrush(BitBrush);
         }
      break;
   }
 return FALSE;
}

BOOL CALLBACK SeekDialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM /*lParam*/)
{
 static PAINTSTRUCT PS;
 static RECT Rect;
 static HBITMAP BitBrush;
 static HBRUSH  Brush = 0;

 switch (msg)
   {
    case WM_COMMAND:
      switch (LOWORD(wParam))
        {
         case IDOK:
         case IDSTOP:
            EndDialog(hwndDlg, wParam);
            Stopped = TRUE;
            return TRUE;
        }; break;
    case WM_PAINT:
      if (!_3D)
         {
          BeginPaint(hwndDlg, &PS);
          SelectObject(PS.hdc, Brush);
          GetClientRect(hwndDlg, &Rect);
          Rectangle(PS.hdc, 0, 0, Rect.right, Rect.bottom);
          EndPaint(hwndDlg, &PS);
         }
      break;

     case WM_CTLCOLORSTATIC:
      if (!_3D)
         {
          SetTextColor((HDC) wParam, RGB(0, 0, 0));
          SetBkColor((HDC) wParam, RGB(192, 192, 192));
          return (LRESULT) GetStockObject(LTGRAY_BRUSH);
         }
       else
         break;

     case WM_DESTROY:
       DeleteObject(BitBrush);
      break;

    case WM_INITDIALOG:
      EnableWindow(GetDlgItem(hwndDlg, 1), FALSE);
      if (!_3D)
         {
          BitBrush = LoadBitmap(MainInstance, MAKEINTRESOURCE(100));
          Brush = CreatePatternBrush(BitBrush);
         }
      break;
   }
 return FALSE;
}

long FAR PASCAL _export WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
 PAINTSTRUCT PS;
 int X, Y;
 char* p;
 char* p1;
 char* SaveP;
 static HBITMAP Opened, Closed, OpenOld, CloseOld;
 static HDC Odc = 0;
 static HDC Cdc = 0;
 static HPEN HPen, OPen;
 POINT  Old;
 SIZE size;
 WINDOWPLACEMENT wndplace;
 int Level;
 int Len = 0;

 switch (message) {
     case WM_LBUTTONDBLCLK:
          DestroyWindow(hwnd);
          ClickClick = TRUE;
          return TRUE;
     case WM_PAINT:
          BeginPaint(hwnd, &PS);
          p = strdup(ThePath);
          SaveP = p;
          if (!Odc)
             {
              Odc = CreateCompatibleDC(PS.hdc);
              OpenOld = SelectObject(Odc, Opened);
             }
          if (!Cdc)
             {
              Cdc = CreateCompatibleDC(PS.hdc);
              CloseOld = SelectObject(Cdc, Closed);
             }
          HPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
          OPen = SelectObject(PS.hdc, HPen);
          X = 2;
          Y = 2;
          p = strtok(p, "/");
          BitBlt(PS.hdc, X, Y, 20, 16, Odc, 0, 0, SRCCOPY);
          while (p)
             {
              TextOut(PS.hdc, X + 22, Y, p, strlen(p));
              p = strtok(NULL, "/");
              if (p)
                 {
                  MoveToEx(PS.hdc, X + 10, Y + 18, &Old);
                  Y += 8;
                  LineTo(PS.hdc, X + 10, Y + 18);
                  X += 12;
                  LineTo(PS.hdc, X + 10, Y + 18);
                  X+=10;
                  Y+=10;
                  BitBlt(PS.hdc, X, Y, 20, 16, Cdc, 0, 0, SRCCOPY);
                 }
             };
          SelectObject(PS.hdc, OPen);
          DeleteObject(HPen);
          free(SaveP);
          EndPaint(hwnd, &PS);
          return TRUE;
     case WM_CREATE:
          Opened = LoadBitmap(MainInstance, MAKEINTRESOURCE(102));
          Closed = LoadBitmap(MainInstance, MAKEINTRESOURCE(101));
          p1 = strdup(ThePath);
          p = strtok(p1, "/");
          Level = 0;
          while (p)
             {
              Level++;
              if (p)
                 {
                  if (((Level * 22) + strlen(p)) > Len)
                     Len = (Level * 22) + strlen(p);
                 }
              p = strtok(NULL, "/");
             }
          free(p1);
          PS.hdc = GetDC(hwnd);
          SetMapMode(PS.hdc, MM_TEXT);
          GetTextExtentPoint32(PS.hdc, "W", 1, &size);
          GetWindowPlacement(hwnd, &wndplace);
          Len -= (Level *22);
          Len *= size.cx;
          MoveWindow(hwnd, wndplace.rcNormalPosition.left, wndplace.rcNormalPosition.top,
                     Len + 48 + (Level * 22), Level * size.cy + 48,  TRUE);
          DeleteDC(PS.hdc);
          break;
     case WM_DESTROY:
          SelectObject(Odc, OpenOld);
          SelectObject(Cdc, CloseOld);
          DeleteObject(Opened);
          DeleteObject(Closed);
          Cdc = 0;
          Odc = 0;
          break;
    }
 return(DefWindowProc(hwnd,message,wParam,lParam));
}


void CheckValue(HKEY /*Key*/, char *Path, char *data)
{
 WNDCLASS wndclass;
 MSG msg;
 HWND hwnd;
 BOOL Ok;

 ThePath = new char[MAX_PATH];
 strcpy(ThePath, Path);
 if (ThePath[strlen(ThePath) - 1] != '\\')
    strcat(ThePath, "/");
 strcat(ThePath, data);
 if (!CaseSensitive)
    {
     strupr(data);
     strupr(Value);
    }

 if (WholeWord)
    Ok = (strcmp(data , Value) == 0);
 else
    Ok = (strstr(data, Value) != NULL);
 if (Ok)
    {
     wndclass.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS; // WINDOW STYLE
     wndclass.lpfnWndProc   = WndProc;                          // WND PROC
     wndclass.cbClsExtra    = 0;                                // EXTRAS
	  wndclass.cbWndExtra    = 0;                                // EXTRAS
     wndclass.hInstance     = MainInstance;                        // APP INSTANCE
     wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);       // CURSOR
     wndclass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
     wndclass.lpszMenuName  = NULL;                             // MENU
     wndclass.lpszClassName = (char*) szWinName;                        // CLASS NAME

     RegisterClass((WNDCLASS*) &wndclass);
     hwnd=CreateWindow(szWinName,                      // WINDOW CLASS NAME
                       szWinName,                      // WINDOW CAPTION
                       WS_OVERLAPPED,                  // WINDOW STYLE
                       CW_USEDEFAULT,                  // INITIAL X POSITION
                       CW_USEDEFAULT,                  // INITIAL Y POSITION
                       400,                            // INITIAL X SIZE
                       300,                            // INITIAL Y SIZE
                       NULL,                           // PARENT WINDOW HANDLE
                       NULL,                           // WINDOW MENU HANDLE
                       MainInstance,                      // PROGRAM INSTANCE HANDLE
                       NULL);                          // CREATION PARAMETERS

     if (hwnd)
        ShowWindow(hwnd, SW_SHOWNORMAL);
     while (!ClickClick)
        {
         PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
         TranslateMessage(&msg);
         DispatchMessage(&msg);
        }
     ClickClick = FALSE;
    }
 delete ThePath;
}

HKEY SearchKey(HKEY Key, char* Name)
{
 int   KEYnum = 0;
 int   iValue = 0;
 DWORD valuelen = MAX_PATH;
 DWORD datalen = MAX_PATH;
 HKEY  KEYKey;
 LONG  Error, NoMoreKey;
 MSG   msg;
 char  name[MAX_PATH];

 memset(name, 0, MAX_PATH);
 strcpy(name, Name);
 do {
     memset(SubKeyName, 0, 100);
     strncpy(SubKeyName, name, 90);
     strncat(SubKeyName, "/", 90);
     NoMoreKey = RegEnumKey(Key, KEYnum++, KEYname, MAX_PATH);
     if (!NoMoreKey)
      {
       Error = RegOpenKey(Key, &KEYname[0], &KEYKey);
       strncat(SubKeyName, KEYname, 90);
       if (!Error)
         SearchKey(KEYKey, SubKeyName);
       if (KEYKey!= TheKey)
       do {
           Error = RegEnumValue(KEYKey, iValue++, valueStr, &valuelen, NULL, NULL, data, &datalen);
           if (!Error)
              {
               memset(value, 0, 100);
               strncpy(value, SubKeyName, 90);
               strncat(value, valueStr,  90);
               SendDlgItemMessage(Dialog, 101, WM_SETTEXT, 0, (LPARAM) value);
               CheckValue(KEYKey, (char*) value, (char*) data);
              }
           valuelen = MAX_PATH;
           datalen = MAX_PATH;
           PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
           TranslateMessage(&msg);
           DispatchMessage(&msg);
          } while ((Error == ERROR_SUCCESS) && (!Stopped));
       iValue = 0;
       RegCloseKey(KEYKey);
      }
    } while ((!NoMoreKey) && (!Stopped));
 return KEYKey;
}

